/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dijit/layout/TabContainer", "dijit/layout/ContentPane",  
		"./copybookOverviewPane", /*The default overviews */ 
		"./copybookDefinition", 
		"./entitiesSelectionLinesPane",		
		"./keywordsPane", /* The keywords pane */
		"./gLinesPane",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PTEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
], function ( TabContainer, ContentPane, copybookOverviewPane, copybookDefinition, entitiesSelectionLinesPane, keywordsPane, gLinesPane, PTEditor, PacbaseEditor ) {
	return {
		getTab : function ( data, type, project, streamId, compentId, fileItemId ) {
			var tc = new TabContainer( {				
			} );
		
			// Overview
			var cpOverview = new ContentPane( {
				title : PTEditor.OVERVIEW_TABTEXT,
			} );
			cpOverview.addChild( copybookOverviewPane.getOverview( data, type, project, streamId, compentId, fileItemId ) );
			tc.addChild( cpOverview );
			
			// definition
			var cpDefinition = new ContentPane( {
				title : PacbaseEditor.COPY_SECTION_HEADER,
			} );
			cpDefinition.addChild( copybookDefinition.getDetailDefinition(data, type, project, streamId, compentId, fileItemId ) );
			tc.addChild( cpDefinition );
			
			// selection
			var cpSelection = new ContentPane( {
				title : PacbaseEditor.COPY_SELECTION_TABTEXT,
			} );
			
			
			cpSelection.addChild( entitiesSelectionLinesPane.getDetailLines( data, type, project, streamId, compentId, fileItemId, PacbaseEditor.COPY_SELECTION_TABTEXT, PacbaseEditor.COPY_LSLINE_TABLE_SECTION_DESCRIPTION, 
					PacbaseEditor.LSLINE_SEGMENT, PacbaseEditor.COPY_COLUMN_TOOL_TIP_SELECTED_LIST) );
			tc.addChild( cpSelection );

			// -G Lines
			var gGLines = new ContentPane( {
				title : PacbaseEditor.GLINE_TABTEXT,
			} );
			gGLines.addChild( gLinesPane.getGLines( data, type,  true, false, false, false, streamId, project ) );
			tc.addChild( gGLines );		
			
			
			// Keywords
			var keywords = data.keywords;
			var cpKeywords = new ContentPane( {
				title : PTEditor.KEYWORD_SECTION_HEADER,
			} );
			cpKeywords.addChild( keywordsPane.getDetailKeywords( keywords, type ) );
			tc.addChild( cpKeywords );

			return tc;
		}
	};
} );