/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dojox/layout/TableContainer", "dijit/layout/ContentPane", "dijit/form/TextBox", "dijit/form/Textarea",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacEnumerationLabel"
], function ( TableContainer, ContentPane, TextBox, TextArea, PacbaseEditor, PacEnumerationLabel ) {
	function baseDefinition (data, project, streamId) {
		
		var definitionTable = new TableContainer( {
			labelWidth : rppDefaultLabelWidth,
		} );

		if ( data.pacBlockBase != "" ) {
			var psbPane = new com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.RadicalEntityWidget(PacbaseEditor.DIALOG_PSB_SUB_SCHEMA_CODE,  data.pacBlockBase, true, streamId, project);
			definitionTable.addChild( psbPane );
		} else {
			var noPsb = new TextBox( {
				label : PacbaseEditor.DIALOG_PSB_SUB_SCHEMA_CODE,
				value : "",
				disabled : true,
				style : {
					"width" : rppDefaultTextWidth
				}
			} );
			definitionTable.addChild( noPsb );
			
		}
		
		var firstScreen = new TextBox( {
			label : PacbaseEditor.DIALOG_FIRST_SCREEN,
			value : data.firstScreenCode,
			disabled : true,
			style : {
				"width" : rppDefaultTextWidth
			}
		});
		definitionTable.addChild(firstScreen);
		
		var options = new TextArea( {
			label : PacbaseEditor.DIALOG_COMPLEMENT_OPTIONS,
			//value : "WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW",
			value : data.options,
			disabled : true,
			style : {
				"width" : rppDefaultTextWidth
			}
		});
		definitionTable.addChild(options);
		
		return definitionTable;
	}
	function commonAreaDefinition (data, project, streamId) {
		var comAreaTable = new TableContainer( {
			labelWidth : rppDefaultLabelWidth,
		} );
			
		if ( data.commonArea != "" ) {
			var commonAreaPane = new com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.RadicalEntityWidget(PacbaseEditor.DIALOG_COMMON_AREA_REFERENCE,  data.commonArea, true, streamId, project);
			comAreaTable.addChild( commonAreaPane );
		} else {
			var noCommonArea = new TextBox( {
				label : PacbaseEditor.DIALOG_COMMON_AREA_REFERENCE,
				value : PacbaseEditor.DIALOG_NO_COMMON_AREA_REFERENCE,
				disabled : true,
				style : {
					"width" : rppDefaultTextWidth
				}
			} );
			comAreaTable.addChild( noCommonArea );
			
		}

		var cmplCommonAreaLength = new TextBox( {
			label : PacbaseEditor.DIALOG_COMPLEMENT_COMMON_AREA_LENGTH,
			value : data.complementCommonAreaLength,
			disabled : true,
			style : {
				"width" : rppDefaultTextWidth
			}
		} );
		comAreaTable.addChild( cmplCommonAreaLength );
		
		return comAreaTable;
	}

	function errorLabelDefinition (data, project, streamId) {
		var errLabTable = new TableContainer( {
			labelWidth : rppDefaultLabelWidth,
		} );
			
		var organization = new TextBox( {
			label : PacbaseEditor.DIALOG_ERR_FILE_ORGANIZATION,
			value : rppEnumVDislayValue(PacEnumerationLabel, data.errorMessageFileOrganization),
			disabled : true,
			style : {
				"width" : rppDefaultTextWidth
			}
		} );
		errLabTable.addChild( organization );

		var externalName = new TextBox( {
			label : PacbaseEditor.DIALOG_ERR_FILE__EXTERNAL_NAME,
			value : data.errorMessageFileExternalName,
			disabled : true,
			style : {
				"width" : rppDefaultTextWidth
			}
		} );
		errLabTable.addChild( externalName );
		
		return errLabTable;
	}

	return {
		getDetailDefinition : function ( data, type, project, streamId, compentId, fileItemId  ) {
			var detailDefinition;
			require( [
				"dojo/string"
			], function ( string ) {
				detailDefinition = new ContentPane( {
					content : "<strong>" + PacbaseEditor.DIALOG_COMPLEMENT + ": </strong><hr><P>"
							+ PacbaseEditor.DIALOG_COMPLEMENT_DESCRIPTION + "</p>",
				} );
			} );
			detailDefinition.addChild( baseDefinition(data, project, streamId) );
			
			var commonAreaLabel = new ContentPane( {
				content : "<strong>" + PacbaseEditor.DIALOG_COMMON_AREA + "</strong>",
			} );
			detailDefinition.addChild( commonAreaLabel);
			detailDefinition.addChild( commonAreaDefinition(data, project, streamId) );
			
			var errorLabel = new ContentPane( {
				content : "<strong>" + PacbaseEditor.DIALOG_ERR_FILE + "</strong>",
			} );
			detailDefinition.addChild( errorLabel);
			detailDefinition.addChild( errorLabelDefinition(data, project, streamId) );

			return detailDefinition;
		}
	};
} );