/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016, 2017. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dijit/TooltipDialog", "dojo/string", "dojox/layout/TableContainer", "dijit/layout/ContentPane", "dijit/form/TextBox", "dijit/tree/ForestStoreModel",
		'dojox/grid/DataGrid', 'dojo/data/ItemFileReadStore', "dijit/TooltipDialog", "dijit/form/CheckBox",
		"dojo/data/ItemFileWriteStore", "dojox/grid/LazyTreeGrid", "dijit/form/Button", "dijit/Dialog", "./gLinesPane",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/typeDict",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacEnumerationLabel"
], function ( TooltipDialog, string, TableContainer, ContentPane, TextBox, ForestStoreModel, DataGrid, ItemFileReadStore, TooltipDialog, CheckBox, ItemFileWriteStore, LazyTreeGrid, Button, Dialog, gLinesPane, 
				PacbaseEditor, typeDict, PacEnumerationLabel ) {
	function getDataDescription ( dataDescription ) {
		if ( dataDescription != undefined && dataDescription != "" ) {
			var dataDescription = dataDescription.filter( function ( item ) {
				return item.facet == "kernel";
			} )[ 0 ];
			return dataDescription != undefined
					? dataDescription : ""
		} else {
			return "";
		}
	}

	function getExtensionPacbase ( extensions, className ) {
		if ( extensions.length == 0 ) {
			return "";
		} else {
			var extension = extensions.filter( function ( item ) {
				return className != undefined
						? item.facet == "pacbase" && item[ "class" ] == className : item.facet == "pacbase"
			} );
			return extension.length > 0
					? extension[ 0 ] : "";
		}
	}

	function getMoreLinePacbase ( moreLines ) {
		if ( moreLines == undefined || moreLines.length == 0 ) {
			return "";
		} else {
			var moreLine = moreLines.filter( function ( object ) {
				return object.facet == "pacbase";
			} )
			return moreLine.length > 0
					? moreLine[ 0 ] : "";
		}
	}

	function getName ( item, project, streamId  ) {
		if ( item[ "class" ] == "Filler" ) {
			return item[ "class" ];
		} else if ( item.dataDescription[ 0 ][ "class" ] == "DataUnionDescription" ) {
			return PacbaseEditor.REDEFINES;
		} else if ( item.dataDescription[ 0 ][ "class" ] == "DataElementDescription" ) {
			return "<span class='display_icon pacDataElementDescription'></span> " + item.dataDescription[ 0 ].name
		}
		if ( item.dataDefinition == "" )
			return item.dataDescription[ 0 ].name;
		var radicalElement = item.dataDefinition[0];
		return new com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.RadicalEntityWidget("", radicalElement, false, streamId, project); 
	}

	function getLabel ( item ) {
		if ( item[ "class" ] == "Filler" ) {
			var extension = getExtensionPacbase( item.extensions, "PacFiller" );
			return extension != ""
					? extension.label : "";
		} else {
			var dataDescription = getDataDescription( item.dataDescription );
			return dataDescription != ""
					? ( dataDescription[ "class" ] == "DataUnionDescription"
							? PacbaseEditor.REDEFINES : dataDescription.label ) : item.dataDefinition[ 0 ].label;
		}
	}

	function getFormat ( item ) {
		if ( item[ "class" ] == "Filler" ) {
			var extension = getExtensionPacbase( item.extensions, "PacFiller" );
			return extension != ""
					? extension.format : "";
		} else {
			var dataDescription = getDataDescription( item.dataDescription );
			if ( dataDescription != "" ) {
				if ( dataDescription[ "class" ] == "DataElementDescription" )
					return getExtensionPacbase( dataDescription.extensions, "PacDataElementDescription" ).internalFormat;
				else
					return "";
			} else {
				return item.dataDefinition.length > 0
						? ( item.dataDefinition[ 0 ].internalFormat != undefined
								? item.dataDefinition[ 0 ].internalFormat : "" ) : "";
			}
		}
	}

	function getUsage ( item ) {
		if ( item[ "class" ] == "Filler" ) {
			var extension = getExtensionPacbase( item.extensions, "PacFiller" );
			return extension != ""
					? extension.usage[ 0 ].value : "";
		} else {
			var dataDescription = getDataDescription( item.dataDescription );
			if ( dataDescription != "" ) {
				if ( dataDescription[ "class" ] == "DataElementDescription" )
					return getExtensionPacbase( dataDescription.extensions, "PacDataElementDescription" ).internalUsage[ 0 ].value;
				else
					return "";
			} else {
				return item.dataDefinition.length > 0
						? ( item.dataDefinition[ 0 ].internalUsage != undefined
								? item.dataDefinition[ 0 ].internalUsage : "" ) : "";
			}
		}
	}

	function getOccurs ( item ) {
		return item.maximumCardinality != undefined
				? item.maximumCardinality : "";
	}

	function getSortkey ( item ) {
		var extension = getExtensionPacbase( item.extensions )
		return extension != ""
				? ( extension.sortKey != undefined
						? extension.sortKey : "" ) : "";
	}

	function getPres ( item ) {
		var extension = getExtensionPacbase( item.extensions );
		return extension != ""
				? ( extension.presence != undefined
						? extension.presence[0]["value"].toString().replace("_","").replace("None","") : "" ) : "";
	}
	
	function getDataType ( item ) {
		var extension = getExtensionPacbase( item.extensions );
		return extension != ""
				? ( extension.dataType != undefined
						? extension.dataType[0]["value"].toString().replace("_","").replace("None","") : "" ) : "";
	}	
	
	function getDir ( item ) {
		var extension = getExtensionPacbase( item.extensions )
		if ( extension != "" ) {
			var moreLine = getMoreLinePacbase( extension.moreLines );
			return moreLine != ""
					? ( moreLine.transferDirection != undefined
							? "<a class='edit-current-segment-cemore'  href='#' onclick='return false;'>"+moreLine.transferDirection[0]["value"].toString().replace("_","").replace("None","")+"</a>" : "" ) : "";
		}
		return "";
	}
	
	function getOper ( item ) {
		var extension = getExtensionPacbase( item.extensions )
		if ( extension != "" ) {
			var moreLine = getMoreLinePacbase( extension.moreLines );
			return moreLine != ""
					? ( moreLine.operator != undefined
							? "<a class='edit-current-segment-cemore'  href='#' onclick='return false;'>"+moreLine.operator+"</a>" : "" ) : "";
		}
		return "";
	}	
	
	
	function getSubschemes ( item ) {
		var extension = getExtensionPacbase( item.extensions );
		if ( extension == "" || extension.subSchemaAssignment == undefined)
			return "";
		var ssa = extension.subSchemaAssignment[0];
		if( ssa.subSchema1 == undefined )
			return "";
		var result = ssa.subSchema1 + ssa.subSchema2 + ssa.subSchema3 + ssa.subSchema4 + ssa.subSchema5
							+ ssa.subSchema6 + ssa.subSchema7 + ssa.subSchema8 + ssa.subSchema9 + ssa.subSchema10;
		result = result.toString().replace(/true/g,"O").replace(/false/g,"&nbsp;");
		return "<a class='edit-current-segment-cemore'  href='#' onclick='return false;'>"+result+"</a>"
	}	
	
	function getCont ( item ) {
		var extension = getExtensionPacbase( item.extensions )
		if ( extension != "" ) {
			var result = "";
			if ( extension.classControl != undefined )
				result += extension.classControl[0]["value"].toString().replace(/_/g,"").replace(/None/g,"&nbsp;");
			var moreLine = getMoreLinePacbase( extension.moreLines );
			result += moreLine.operator != undefined ? moreLine.operator : "&nbsp;";
			result += moreLine.negation != undefined ? moreLine.negation : "&nbsp;";
			result += moreLine.controlType != undefined ? moreLine.controlType : "&nbsp;";
			if ( result.replace(/&nbsp;/g,"").length == 0)
				return "";
			return  "<a class='edit-current-segment-cemore'  href='#' onclick='return false;'>"+result+"</a>";
		}
		return "";
	}

	function getValueSFC ( item ) {
		var extension = getExtensionPacbase( item.extensions )
		if ( extension != "" ) {
			var moreLine = getMoreLinePacbase( extension.moreLines );
			return moreLine != ""
					? ( moreLine.controlValue != undefined
							? "<a class='edit-current-segment-cemore'  href='#' onclick='return false;'>"+moreLine.controlValue.toString().replace(/ /g,"&nbsp;")+"</a>" : "" ) : "";
		}
		return "";
	}

	function getUpdatTarget ( item ) {
		var extension = getExtensionPacbase( item.extensions )
		if ( extension != "" ) {
			var moreLine = getMoreLinePacbase( extension.moreLines );
			return moreLine != ""
					? ( moreLine.updateTarget != undefined
							? "<a class='edit-current-segment-cemore'  href='#' onclick='return false;'>"+moreLine.updateTarget+"</a>" : "" ) : "";
		}
		return "";
	}
	
	
	function getCMS456 ( item ) {
		var extension = getExtensionPacbase( item.extensions )
		if ( extension != "" && extension.presenceCheck != undefined ) {
			var presenceCheck = getMoreLinePacbase( extension.presenceCheck );
			if ( presenceCheck != undefined &&  presenceCheck.inCreation != undefined) {
				var tmp = presenceCheck.inCreation[0]["value"][0]+presenceCheck.inModification[0]["value"][0] + presenceCheck.inDeletion[0]["value"][0]
								+ presenceCheck.inType4[0]["value"][0] + presenceCheck.inType5[0]["value"][0] + presenceCheck.inType6[0]["value"][0] ;
				tmp =  tmp.replace(/_/g,"").replace(/F/g,"&nbsp;").replace(/None/g,"&nbsp;");
				if ( tmp.replace(/&nbsp;/g,"").length == 0)
					return "";
				return "<a class='edit-current-segment-cemore'  href='#' onclick='return false;'>"+tmp+"</a>"
			}
		}
		return "";
	}
		
	function loadCommentsForTooltip( store ) {
		if (store._arrayOfTooltipsCdLineHeader == undefined) {
			var comments = [PacbaseEditor.SEGMENT_CELINE_COLUMN_TOOL_TIP_NAME,
			                PacbaseEditor.SEGMENT_CELINE_COLUMN_TOOL_TIP_LABEL,
			                PacbaseEditor.SEGMENT_CELINE_COLUMN_TOOL_TIP_COMMENTS,
			                PacbaseEditor.SEGMENT_CELINE_COLUMN_TOOL_TIP_FORMAT,
			                PacbaseEditor.SEGMENT_CELINE_COLUMN_TOOL_TIP_USAGE,
			                PacbaseEditor.SEGMENT_CELINE_COLUMN_TOOL_TIP_OCCURS,
			                PacbaseEditor.SEGMENT_CELINE_COLUMN_TOOL_TIP_SORTKEY,
			                PacbaseEditor.SEGMENT_CELINE_COLUMN_TOOL_TIP_CMS456,
			                PacbaseEditor.SEGMENT_CELINE_COLUMN_TOOL_TIP_CONT,
			                PacbaseEditor.SEGMENT_CELINE_COLUMN_TOOL_TIP_VALUE_SFC,
			                PacbaseEditor.SEGMENT_CELINE_COLUMN_TOOL_TIP_UPDATE_TARGET]	        			           
			store._arrayOfTooltipsCdLineHeader = comments;
		}
	}
	
	// data element call
	function getDataElementEditSection ( item ) {
		var cpDataElement = new ContentPane( {
			content : "<strong>" + PacbaseEditor.CELINE_DATA_ELEMENT_EDIT_SECTION_HEADER + "</strong><hr><p>"
					+ PacbaseEditor.CELINE_DATA_ELEMENT_EDIT_SECTION_DESCRIPTION + "</p>",
		} );
		var tableDataElement = new TableContainer( {
			labelWidth : 150,
		} );
		var textOccurs = new TextBox( {
			label : PacbaseEditor.OCCURS,
			value : getOccurs( item ),
			disabled : true
		} );
		var textSortKey = new TextBox( {
			label : PacbaseEditor.SORT_KEY,
			value : getSortkey( item ),
			disabled : true
		} );
		tableDataElement.addChild( textOccurs );
		tableDataElement.addChild( textSortKey );
		cpDataElement.addChild( tableDataElement );
		return cpDataElement;
	}

	// group definition
	function getGroupEditSection ( item ) {
		var cpGroupDefintion = new ContentPane( {
			content : "<strong>" + PacbaseEditor.CELINE_GROUP_EDIT_SECTION_HEADER + "</strong><hr><p>"
					+ PacbaseEditor.CELINE_GROUP_EDIT_SECTION_DESCRIPTION + "</p>",
		} );
		var tableGroupDefintion = new TableContainer( {
			labelWidth : 150,
		} );
		var textName = new TextBox( {
			label : PacbaseEditor.SEGMENT_CELINE_COLUMN_NAME,
			value : getName( item ),
			disabled : true,
			style : {
				width : "250px"
			}
		} );
		var textLabel = new TextBox( {
			label : PacbaseEditor.SEGMENT_CELINE_COLUMN_LABEL,
			value : getLabel( item ),
			disabled : true,
			style : {
				width : "250px"
			}
		} );
		var textOccurs = new TextBox( {
			label : PacbaseEditor.OCCURS,
			value : getOccurs( item ),
			disabled : true,
			style : {
				width : "250px"
			}
		} );
		var textSortKey = new TextBox( {
			label : PacbaseEditor.SORT_KEY,
			value : getSortkey( item ),
			disabled : true,
			style : {
				width : "250px"
			}
		} );
		tableGroupDefintion.addChild( textName );
		tableGroupDefintion.addChild( textLabel );
		tableGroupDefintion.addChild( textOccurs );
		tableGroupDefintion.addChild( textSortKey );

		cpGroupDefintion.addChild( tableGroupDefintion );
		return cpGroupDefintion;
	}
	
	function displayCurrentSegmentCeMore ( dataItem ) {
	    dlg = new dijit.Dialog({
	        title:PacbaseEditor.CELINE_CLASS_MORE,
	        content:getCurrentSegmentCeMorePane(dataItem).domNode
	      });
	    dlg.show();
	}
	
	function getCurrentSegmentCeMorePane ( dataItem ) {
		if ( rppDebug )
			console.debug(dataItem);
		var isLVView = true;
		var className = "PacLogicalViewCall";
		var extension = dataItem.extensions.filter( function ( item ) {
			return className != undefined
					? item[ "class" ] == className : item.facet == "pacbase"
		} );
		
		if ( ! extension || extension.length == 0  ) {
			isLVView = false;
			className = "PacDataCall";
			extension = dataItem.extensions.filter( function ( item ) {
				return className != undefined
						? item[ "class" ] == className : item.facet == "pacbase"
			} );
		}
		
		if ( ! extension || extension.length == 0  ) {
			isLVView = false;
			className = "PacFiller";
			extension = dataItem.extensions.filter( function ( item ) {
				return className != undefined
						? item[ "class" ] == className : item.facet == "pacbase"
			} );
		}

		extension = extension[0];
		if ( rppDebug )
			console.debug(extension);
		
		var cePane = new ContentPane( {
			title : PacbaseEditor.GLINE_TABTEXT,
			style:"overflow:'auto'"
		} );
		
		if ( !isLVView && extension.presenceCheck && extension.presenceCheck[0] ) {
			var presenceCheckPane = new ContentPane( {
				content : "<strong>"+PacbaseEditor.PRESENCE_CHECK_GRP+"</strong><hr>",
			} );
			
			var presenceCheckTable = new TableContainer( {
				cols : 3,
				labelWidth : 150,
				style : {
					"width" : "750px"
				}
			} );
			
			var enumValue = extension.presenceCheck[0].inCreation[0];
			var textBox = TextBox( {
				label : PacbaseEditor.CREATE,
				value : PacEnumerationLabel[enumValue["class"] + enumValue["value"].toString().toUpperCase()],
				disabled : true
			} );
			presenceCheckTable.addChild( textBox );
			
			enumValue = extension.presenceCheck[0].inModification[0];
			textBox = TextBox( {
				label : PacbaseEditor.UPDATE,
				value : PacEnumerationLabel[enumValue["class"] + enumValue["value"].toString().toUpperCase()],
				disabled : true
			} );
			presenceCheckTable.addChild( textBox );

			enumValue = extension.presenceCheck[0].inDeletion[0];
			textBox = TextBox( {
				label : PacbaseEditor.DELETE,
				value : PacEnumerationLabel[enumValue["class"] + enumValue["value"].toString().toUpperCase()],
				disabled : true
			} );
			presenceCheckTable.addChild( textBox );

			enumValue = extension.presenceCheck[0].inType4[0];
			textBox = TextBox( {
				label : PacbaseEditor.UPDATE4,
				value : PacEnumerationLabel[enumValue["class"] + enumValue["value"].toString().toUpperCase()],
				disabled : true
			} );
			presenceCheckTable.addChild( textBox );

			enumValue = extension.presenceCheck[0].inType5[0];
			textBox = TextBox( {
				label : PacbaseEditor.UPDATE5,
				value : PacEnumerationLabel[enumValue["class"] + enumValue["value"].toString().toUpperCase()],
				disabled : true
			} );
			presenceCheckTable.addChild( textBox );
		
			enumValue = extension.presenceCheck[0].inType6[0];
			textBox = TextBox( {
				label : PacbaseEditor.UPDATE6,
				value : PacEnumerationLabel[enumValue["class"] + enumValue["value"].toString().toUpperCase()],
				disabled : true
			} );
			presenceCheckTable.addChild( textBox );
			presenceCheckPane.addChild( presenceCheckTable );
			cePane.addChild( presenceCheckPane );
		} else if ( isLVView && extension.subSchemaAssignment ) {
			var subSchemaAssignmentPane = new ContentPane( {
				content : "<strong>"+PacbaseEditor.CELINE_CLASS_SCHEMAS_GROUP+"</strong><hr>",
			} );
			
			var subSchemaAssignmentTable = new TableContainer( {
				cols : 5,
				labelWidth : 150,
				customClass: "rppCeLineMoreLabelsAndValues",
				style : {
					"width" : "750px"
				}
			} );
			
			var checkBox = new CheckBox( {
				label : PacbaseEditor.CELINE_CLASS_SCHEMA + ' 0',
				checked : extension.subSchemaAssignment[0].subSchema10 == "true",
				disabled : true
			} );
			subSchemaAssignmentTable.addChild( checkBox );
			
			var checkBox = new CheckBox( {
				label : PacbaseEditor.CELINE_CLASS_SCHEMA + ' 1',
				checked : extension.subSchemaAssignment[0].subSchema1 == "true",
				disabled : true
			} );
			subSchemaAssignmentTable.addChild( checkBox );
			
			var checkBox = new CheckBox( {
				label : PacbaseEditor.CELINE_CLASS_SCHEMA + ' 2',
				checked : extension.subSchemaAssignment[0].subSchema2 == "true",
				disabled : true
			} );
			subSchemaAssignmentTable.addChild( checkBox );
			
			var checkBox = new CheckBox( {
				label : PacbaseEditor.CELINE_CLASS_SCHEMA + ' 3',
				checked : extension.subSchemaAssignment[0].subSchema3 == "true",
				disabled : true
			} );
			subSchemaAssignmentTable.addChild( checkBox );
			
			var checkBox = new CheckBox( {
				label : PacbaseEditor.CELINE_CLASS_SCHEMA + ' 4',
				checked : extension.subSchemaAssignment[0].subSchema4 == "true",
				disabled : true
			} );
			subSchemaAssignmentTable.addChild( checkBox );
			
			var checkBox = new CheckBox( {
				label : PacbaseEditor.CELINE_CLASS_SCHEMA + ' 5',
				checked : extension.subSchemaAssignment[0].subSchema5 == "true",
				disabled : true
			} );
			subSchemaAssignmentTable.addChild( checkBox );
			
			var checkBox = new CheckBox( {
				label : PacbaseEditor.CELINE_CLASS_SCHEMA + ' 6',
				checked : extension.subSchemaAssignment[0].subSchema6 == "true",
				disabled : true
			} );
			subSchemaAssignmentTable.addChild( checkBox );
			
			var checkBox = new CheckBox( {
				label : PacbaseEditor.CELINE_CLASS_SCHEMA + ' 7',
				checked : extension.subSchemaAssignment[0].subSchema7 == "true",
				disabled : true
			} );
			subSchemaAssignmentTable.addChild( checkBox );
			
			var checkBox = new CheckBox( {
				label : PacbaseEditor.CELINE_CLASS_SCHEMA + ' 8',
				checked : extension.subSchemaAssignment[0].subSchema8 == "true",
				disabled : true
			} );
			subSchemaAssignmentTable.addChild( checkBox );
			
			var checkBox = new CheckBox( {
				label : PacbaseEditor.CELINE_CLASS_SCHEMA + ' 9',
				checked : extension.subSchemaAssignment[0].subSchema9 == "true",
				disabled : true
			} );
			subSchemaAssignmentTable.addChild( checkBox );
			
			
			subSchemaAssignmentPane.addChild( subSchemaAssignmentTable );
			cePane.addChild( subSchemaAssignmentPane );
		}
		
		if ( !isLVView && extension.classControl ) {
			var classControlPane = new ContentPane( {
				content : "<strong>"+PacbaseEditor.CELINE_CLASS_CONTROL+"</strong><hr>",
			} );
			
			var classControlTable = new TableContainer( {
				cols : 1,
				labelWidth : 150,
				style : {
					"width" : "750px"
				}
			} );
			
			var classControl = extension.classControl[0];
			
			textBox = TextBox( {
				label : PacbaseEditor.CELINE_CLASS_CONTROL,
				value : PacEnumerationLabel[classControl["class"] + classControl["value"].toString().toUpperCase()],
				style : {
					"width" : "50%"
				},
				disabled : true
			} );
			classControlTable.addChild( textBox );
			classControlPane.addChild( classControlTable );
			cePane.addChild( classControlPane );
		}
		
		
		/* set up data store */
		var store = new ItemFileReadStore( {
			data : {
				items : extension.moreLines
			}
		} );	
		
		/* set up layout */	
		var layout = null;
		if ( isLVView ) { 
			layout = [
				{
					'name' : PacbaseEditor.CELINE_CLASS_MORE_TRANSFERT_DIR,
					'field' : 'transferDirection',
					'width' : '200px',						
					formatter : function ( item ) {
						return item["value"].toString().replace("_","").replace("None","");
					},
				},
				{
					'name' : PacbaseEditor.CELINE_CLASS_MORE_TRANSFERT_OP,
					'field' : 'operator',
					'width' : '200px'
				},
				{
					'name' : PacbaseEditor.CELINE_CLASS_MORE_TRANSFERT_AREA,
					'field' : 'updateTarget',
					'width' : '200px'
				},
			]; 
		} 
		else {
			layout = [
				{
					'name' : PacbaseEditor.CELINE_CLASS_MORE_OPERATOR,
					'field' : 'operator',
					'width' : '150px'
				},
				{
					'name' : PacbaseEditor.CELINE_CLASS_MORE_NEGATION,
					'field' : 'negation',
					'width' : '150px'
				},
				{
					'name' : PacbaseEditor.CELINE_CLASS_MORE_CONTROL_TYPE,
					'field' : 'controlType',
					'width' : '150px'
				},
				{
					'name' : PacbaseEditor.CELINE_CLASS_MORE_SUB_FUNCTION,
					'field' : 'controlValue',
					'width' : '150px',
					formatter : function ( item ) {
						if ( item == undefined )
							return "";
						return item.replace(/ /g,"&nbsp;");
					},
				},
				{
					'name' : PacbaseEditor.CELINE_CLASS_MORE_UPDT_TARGET,
					'field' : 'updateTarget',
					'width' : '150px'
				},
			]; 			
		}

		/* create a new grid */
		var moreLinesGrid = new DataGrid( {
			store : store,
			structure : layout,
			autoHeight : true,
			autoWidth : true,
			style : {
				'overflow' : 'auto',
				"width" : "100%"
			},
			selectable : true,
			canSort : function () {
				return false;
			},	
			onStyleRow: function (row) {
				row.customClasses = "rppGridFixedDefaultFont";
			},
		} );			
		
		
		var gridPane = new ContentPane( {
			content : "<strong>"+PacbaseEditor.CELINE_CLASS_MORE+"</strong><hr>",
		} );

		gridPane.addChild( moreLinesGrid );
		cePane.addChild( gridPane );		
		

		
		return cePane;
	}

	return {
		getOverviewCELines : function ( components, type ) {
			var cpOverviewCELines = new ContentPane( {
				content : "<hr><strong>" + PacbaseEditor.CELINE_SECTION_HEADER + ": </strong><P>"
						+ string.substitute( PacbaseEditor.CELINE_SECTION_DESCRIPTION, [
							typeDict[ type ]
						] ) + "</p>",
			} );
			if ( components.length != 0 ) {
				var CELinesContent = "<ul>"
				components.forEach( function ( item ) {
					var name = ( function () {
						if ( item[ "class" ] == "Filler" ) {
							return item[ "class" ];
						} else if ( item.dataDescription[ "class" ] == "DataUnionDescription" ) {
							return PacbaseEditor.REDEFINES;
						}
						return item.dataDefinition != ""
								? item.dataDefinition.name : item.dataDescription.name;
					} )();
					CELinesContent += "<li>";
					CELinesContent += name;
					CELinesContent += "</li>";
				} );
				CELinesContent += "</ui>";
				var CELinesPane = new ContentPane( {
					content : CELinesContent,
					style : {
						height : "100px"
					}
				} );
				cpOverviewCELines.addChild( CELinesPane );
			}
			return cpOverviewCELines;
		},
		getDetailCELines : function ( segmentType, components, type, project, streamId ) {

			var cpDetailCELines = new ContentPane( {
				content : "<strong>" + PacbaseEditor.CELINE_TABLE_SECTION_HEADER + ": </strong><hr><P>"
						+ string.substitute( PacbaseEditor.CELINE_TABLE_SECTION_DESCRIPTION, [
							typeDict[ type ]
						] ) + "</p>",
						style : {
							'overflow' : 'auto',
						},
			} );
			// prepare lazy tree grid
			var layoutCELines = [
					{
						name : PacbaseEditor.SEGMENT_CELINE_COLUMN_NAME,
						width : "150px",
						field : "_item",
						formatter : function ( item ) {
							return getName( item, project, streamId  );
						},

					}, {
						name : PacbaseEditor.SEGMENT_CELINE_COLUMN_LABEL,
						width : "200px",
						field : "_item",
						formatter : function ( item ) {
							return getLabel( item );
						}
					}, {
						name : PacbaseEditor.SEGMENT_CELINE_COLUMN_COMMENTS,
						width : "30px",
						field : "_item",
						formatter : function ( item ) {
							if ( item.extensions == undefined || item.extensions[0] == undefined )
								return "";
							var  extension = item.extensions[0];
							var hasComment = (extension.GCLines != undefined && extension.GCLines.length != 0) 
													|| (extension.GELines != undefined && extension.GELines.length != 0 ) 
													|| (extension.GGLines != undefined && extension.GGLines.length != 0 );
							if ( hasComment == false )
								return "";
							var w = new dijit.form.Button({
								label: PacbaseEditor.GLINE_TABTEXT,
								showLabel: false,
								iconClass:'arrrow',
								onClick: function(){
									// -G Lines
									var cpGLines = new ContentPane( {
										title : PacbaseEditor.GLINE_TABTEXT,
										style:"width:"+rppCurrentPaneWidth+"px;height:"+rppCurrentPaneHeight+"px;"
									} );
									cpGLines.addChild( gLinesPane.getGLines ( item.extensions[0], type, true, true, true, false, streamId, project ) );
								    dlg = new dijit.Dialog({
								        title:PacbaseEditor.GLINE_TABTEXT,
								        content:cpGLines.domNode
								      });
								    dlg.show();
						        }								
							});
							w._destroyOnRemove = true;
							
//						    require(["dojo/on"], function(on){
//						    	var ceCommentTooltipDialog = null;
//						    	on(w.domNode, 'mouseover', function(){
//									// -G Lines
//									var cpGLines = new ContentPane( {
//										title : PacbaseEditor.GLINE_TABTEXT,
//										style:"overflow:'auto'"
//									} );
//									
//									
//									cpGLines.addChild( gLinesPane.getGLines ( item.extensions[0], type, true, true, true, false, streamId, project ) );
//									cpGLines.startup();
//								    ceCommentTooltipDialog = new TooltipDialog({
//								    	style:"overflow:'auto'",
//								        //content: cpGLines.domNode,
//								        onMouseLeave: function(){
//								        	dijit.popup.close(ceCommentTooltipDialog);
//								        }
//								    });
//								    
//								    ceCommentTooltipDialog.addChild(cpGLines);
//								    ceCommentTooltipDialog.startup();
//								    
//							    	dijit.popup.open({
//							            popup: ceCommentTooltipDialog,
//							            around: w.domNode
//							        });
//							    });
//						    	on(w.domNode, 'mouseleave', function(){
//						    		dijit.popup.close(ceCommentTooltipDialog);
//							    });
//						    });

							return w;
						}
					}, {
						name : PacbaseEditor.SEGMENT_CELINE_COLUMN_FORMAT,
						width : "100px",
						field : "_item",
						formatter : function ( item ) {
							return getFormat( item );
						}
					}, {
						name : PacbaseEditor.SEGMENT_CELINE_COLUMN_USAGE,
						field : "_item",
						formatter : function ( item ) {
							var usage = getUsage( item );
							if ( usage != undefined ) {
								usage = usage.toString().replace("_","");
							}
							return usage;
						}
					}, {
						name : PacbaseEditor.SEGMENT_CELINE_COLUMN_OCCURS,
						field : "_item",
						formatter : function ( item ) {
							return getOccurs( item );
						}
					}
			];
			
			if ( "_V" == segmentType ) {
				layoutCELines.push(
					{
						name : PacbaseEditor.LOGICAL_VIEW_CELINE_COLUMN_TYPE,
						field : "_item",
						formatter : function ( item ) {
							return getDataType( item );
						}
					}, {
						name : PacbaseEditor.LOGICAL_VIEW_CELINE_COLUMN_PRES,
						field : "_item",
						formatter : function ( item ) {
							return getPres( item );
						}
					}, {
						name : PacbaseEditor.LOGICAL_VIEW_CELINE_COLUMN_DIR,
						field : "_item",
						formatter : function ( item ) {
							return getDir( item );
						},
					},{
						name : PacbaseEditor.LOGICAL_VIEW_CELINE_COLUMN_OPER,
						field : "_item",
						formatter : function ( item ) {
							return getOper( item );
						}
					}, {
						name : PacbaseEditor.LOGICAL_VIEW_CELINE_COLUMN_SUBSCHEMES,
						field : "_item",
						width : "100px",
						formatter : function ( item ) {
							return getSubschemes( item );
						}
					}, {
						name : PacbaseEditor.LOGICAL_VIEW_CELINE_COLUMN_TRANSFER_AREA,
						field : "_item",
						width : "100px",
						formatter : function ( item ) {
							return getUpdatTarget( item );
						}
					}  
				);
			} else {
				layoutCELines.push(
						{
							name : PacbaseEditor.SEGMENT_CELINE_COLUMN_SORTKEY,
							field : "_item",
							formatter : function ( item ) {
								return getSortkey( item );
							}
						}, {
							name : PacbaseEditor.SEGMENT_CELINE_COLUMN_CMS456,
							field : "_item",
							formatter : function ( item ) {
								return getCMS456( item );
							},
						},{
							name : PacbaseEditor.SEGMENT_CELINE_COLUMN_CONT,
							field : "_item",
							formatter : function ( item ) {
								return getCont( item );
							},
						}, {
							name : PacbaseEditor.SEGMENT_CELINE_COLUMN_VALUE_SFC,
							field : "_item",
							formatter : function ( item ) {
								return getValueSFC( item );
							},
						}, {
							name : PacbaseEditor.SEGMENT_CELINE_COLUMN_UPDATE_TARGET,
							field : "_item",
							formatter : function ( item ) {
								return getUpdatTarget( item );
							},
							width : "100px",
						}  
					);				
			}
			
			// prepare lazy tree grid
			var data = {
				items : components
			};
			var store = new ItemFileWriteStore( {
				data : data,
			} );
			var model = new ForestStoreModel( {
				store : store,
				mayHaveChildren : function ( item ) {
					if ( item.dataDescription != undefined && item.dataDescription != "" ) {
						var dataDescription = item.dataDescription.filter( function ( object ) {
							return object.facet == "kernel";
						} )[ 0 ];
						if ( "redefines" in dataDescription ) {
							return dataDescription.redefines.length > 0
						}
						return dataDescription.components != undefined
								? dataDescription.components.length > 0 : false
					} else {
						return false
					}
				},
				getChildren : function ( item, onComplete, onError ) {
					var dataDescription = item.dataDescription.filter( function ( object ) {
						return object.facet == "kernel";
					} )[ 0 ];
					if ( "redefines" in dataDescription ) {
						onComplete( dataDescription.redefines );
					} else {
						onComplete( item.dataDescription[ 0 ].components );
					}
				},
			} );
			var grid = new LazyTreeGrid( {
				treeModel : model,
				structure : layoutCELines,
				height : ( rppCurrentPaneGridHeight ) + "px",
				autoWidth : true, 
				selectable : true,
				canSort : function () {
					return false;
				},
				onHeaderCellMouseOver  : function (e) {
					loadCommentsForTooltip(this.store);
					dijit.showTooltip(this.store._arrayOfTooltipsCdLineHeader[e.cellIndex], e.cellNode);
				},
				onHeaderCellMouseOut : function (e) {
					dijit.hideTooltip(e.cellNode);
				},	
				onStyleRow: function (row) {
					row.customClasses = "rppGridFixedDefaultFont";
				},
			} );
			
			var segmentCeMoreTooltipDialog = null;
			grid.on('a.edit-current-segment-cemore:click', function (event) {
				if ( segmentCeMoreTooltipDialog ) {
					dijit.popup.close(segmentCeMoreTooltipDialog);
					segmentCeMoreTooltipDialog.destroy();
					segmentCeMoreTooltipDialog = null;
				}
				displayCurrentSegmentCeMore(event.grid.getItem(event.rowIndex));
			});
			
			grid.on('a.edit-current-segment-cemore:mouseover', function (event) {
				var cpPane = getCurrentSegmentCeMorePane(event.grid.getItem(event.rowIndex));
				cpPane.startup();

			    var segmentCeMoreTooltipDialog = new TooltipDialog({
			    	style: "width:100%;height:100%;",
			        onMouseLeave: function(){
			        	dijit.popup.close(segmentCeMoreTooltipDialog);
			        },

			    });
			    segmentCeMoreTooltipDialog.addChild(cpPane);
			    segmentCeMoreTooltipDialog.startup();
		    	dijit.popup.open({
		            popup: segmentCeMoreTooltipDialog,
		            around: event.cellNode
		        });
		    	require(["dojo/on"], function(on){
		    		on(event.cellNode, 'mouseleave', function(){
		    			if ( segmentCeMoreTooltipDialog ) {
		    				dijit.popup.close(segmentCeMoreTooltipDialog);
		    				segmentCeMoreTooltipDialog.destroy();
		    				segmentCeMoreTooltipDialog = null;
		    			}
				    });
		    	});
			});
			
			console.debug(grid);
			cpDetailCELines.addChild( grid );
			return cpDetailCELines;
		}
	}
} );