/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dijit/layout/ContentPane", "./generalInfoPane", "./segmentDefinition", "./segmentCELines", "./segmentSQL", "./gLinesPane",
		"./keywordsPane"
], function ( ContentPane, generalInfoPane, segmentDefinition, segmentCELines, segmentSQL, gLinesPane, keywordsPane ) {
	return {
		getOverview : function ( data, type, project, streamId, compentId, fileItemId ) {
			var overview = new ContentPane( {
				title : data.name,
				closable : true,
			} );

			// set the general information
			overview.addChild( generalInfoPane.getGeneralInfo( type, project, data.name, data.label ) );

//			// set segment definition
//			var extensions = data.extensions.filter( function ( object ) {
//				return object.facet === "pacbase";
//			} );
//			if ( extensions.length === 1 ) {
//				var extension = extensions[ 0 ];
//				var tableNumber = "";
//				var transfertDirection; 
//				var segmentType = extension.dataAggregateType["value"];
//				
//				var structureCodeValue = extension.structureCodeValue;
//				var actionCodeValue = extension.actionCodeValue;
//				
//				if ( "_None" == segmentType && 
//						extension.alias != undefined && extension.alias.endsWith("00")) {
//					structureCodeValue = extension.structureCode;
//				    actionCodeValue = extension.actionCode;
//				} 
//				
//				if ( extension.tableAttributes != undefined )
//					tableNumber = extension.tableAttributes.tableNumber;
//				if ( extension.logicalViewAttributes != undefined )
//					transfertDirection = extension.logicalViewAttributes.transfertDirection;
//				
//				var overviewDefinition = segmentDefinition.getOverviewDefinition( extension.tableSize, extension.occurencesNumber,
//						structureCodeValue, actionCodeValue, segmentType, tableNumber, transfertDirection, type );
//				
//				overview.addChild( overviewDefinition );
//
//				// set segment CE lines
//				// overview.addChild( segmentCELines.getOverviewCELines( data.dataDescription.components, type ) );
//				
////				if ( "_None" == segmentType ) {
////					// set segment SQL complement
////					overview.addChild( segmentSQL.getOverviewSQLComplement() );
////				}
//				
//				// set -G lines
//				// overview.addChild( gLinesPane.getOverviewGLines( type ) );				
//			}

			// set keyword
			overview.addChild( keywordsPane.getOverviewKeywords( data.keywords, type ) );

			return overview;
		}
	};
} );